Bug 992430 - pandoc: FTBFS in rawhide with llvm
pandoc: FTBFS in rawhide with llvm
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: pandoc (Show other bugs)
20
All Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
opt hangs
:
Depends On: 992362
Blocks: ARMTracker F20FTBFS 992364
  Show dependency treegraph
 
Reported: 2013-08-05 00:27 EDT by Dennis Gilmore
Modified: 2014-09-05 01:52 EDT (History)
2 users (show)

See Also:
Fixed In Version: pandoc-1.12.3.3-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-09-05 01:52:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Dennis Gilmore 2013-08-05 00:27:39 EDT
Your package pandoc failed to build from source in current rawhide.

http://koji.fedoraproject.org/koji/taskinfo?taskID=5724879

Build logs:
root.log: http://kojipkgs.fedoraproject.org/work/tasks/4879/5724879/root.log
build.log: http://kojipkgs.fedoraproject.org/work/tasks/4879/5724879/build.log
state.log: http://kojipkgs.fedoraproject.org/work/tasks/4879/5724879/state.log
NOTE: build logs are cleaned up after 1 week

For details on mass rebuild see https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild
Comment 1 Jens Petersen 2013-08-20 11:33:49 EDT
Build hangs after:

[ 8 of 45] Compiling Text.Pandoc.Pretty ( src/Text/Pandoc/Pretty.hs, dist/build/Text/Pandoc/Pretty.o )

http://koji.fedoraproject.org/koji/taskinfo?taskID=5833307
Comment 2 Jens Petersen 2013-08-20 11:40:38 EDT
Apparently hanging like this:

12957 ?        S      0:01                  \_ ./Setup build
12958 ?        Sl     0:20                      \_ /usr/lib/ghc-7.6.3/ghc -B/usr/lib/ghc-7.6.3 -optc-I/usr/include --make -fbuilding-cabal-package -O -odir dist/build -hidir dist/build -stubdi
13054 ?        Z      0:00                          \_ [llc] <defunct>
13063 ?        Z      0:00                          \_ [llc] <defunct>
13075 ?        Z      0:00                          \_ [llc] <defunct>
13081 ?        Z      0:00                          \_ [llc] <defunct>
13088 ?        Z      0:00                          \_ [llc] <defunct>
13102 ?        Z      0:00                          \_ [llc] <defunct>
13110 ?        Z      0:00                          \_ [llc] <defunct>
13128 ?        Z      0:00                          \_ [llc] <defunct>
13133 ?        R      9:01                          \_ /usr/bin/opt /tmp/ghc12958_0/ghc12958_0.ll -o /tmp/ghc12958_0/ghc12958_0.bc -O2 --enable-tbaa=true
Comment 3 Jens Petersen 2013-08-21 01:11:45 EDT
http://koji.fedoraproject.org/koji/taskinfo?taskID=5833307

After 4-5 hours got:

[ 8 of 45] Compiling Text.Pandoc.Pretty ( src/Text/Pandoc/Pretty.hs, dist/build/Text/Pandoc/Pretty.o )
terminate called after throwing an instance of 'std::bad_alloc'
  what():  std::bad_alloc
0  libLLVM-3.3.so 0xb6273808 llvm::sys::PrintStackTrace(_IO_FILE*) + 64
1  libLLVM-3.3.so 0xb62735b4
2  libc.so.6      0xb596bfd0 __default_sa_restorer_v2 + 0
3  libc.so.6      0xb596abc4 gsignal + 52
4  libc.so.6      0xb596c1c4 abort + 408
5  libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
6  libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
7  libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
8  libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
9  libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
10 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
:
:
249 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
250 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
251 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
252 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
253 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
254 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
255 libstdc++.so.6 0xb5b70a04 __gnu_cxx::__verbose_terminate_handler() + 360
Stack dump:
0.	Program arguments: /usr/bin/opt /tmp/ghc12958_0/ghc12958_0.ll -o /tmp/ghc12958_0/ghc12958_0.bc -O2 --enable-tbaa=true 
1.	Running pass 'CallGraph Pass Manager' on module '/tmp/ghc12958_0/ghc12958_0.ll'.
/usr/bin/llc: /tmp/ghc12958_0/ghc12958_0.bc: error: Could not open input file: No such file or directory
error: Bad exit status from /var/tmp/rpm-tmp.zyCONd (%build)
Comment 4 Fedora End Of Life 2013-09-16 11:33:21 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 20 development cycle.
Changing version to '20'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora20
Comment 5 Christopher Meng 2013-10-11 22:06:58 EDT
youtube-dl depends on it and it's not available on ARM platform, I think it's caused by llvm defect(not sure).

Tracking.
Comment 6 Jens Petersen 2013-10-15 23:43:09 EDT
I am hoping things will be better with ghc-7.8 which should support llvm-3.3.
Comment 7 Jens Petersen 2013-10-15 23:45:16 EDT
$ repoquery-BR pandoc
autojump-0:21.1.2-3.fc19.src
git-ftp-0:0.84-1.fc19.src
youtube-dl-0:2013.10.07-1.fc19.src
Comment 8 Christopher Meng 2013-12-14 04:22:04 EST
youtube-dl no longer depends on pandoc.
Comment 9 Jens Petersen 2014-02-06 04:53:10 EST
Latest conduit now seems to build on ARM which might help.
Comment 10 Jens Petersen 2014-05-09 05:40:59 EDT
Having built the conduit stack now it seems that the pandoc build hangs on ARM:

:
+ ./Setup build
Building pandoc-1.12.3.3...
Preprocessing library pandoc-1.12.3.3...
[ 1 of 55] Compiling Text.Pandoc.Asciify ( src/Text/Pandoc/Asciify.hs, dist/build/Text/Pandoc/Asciify.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 2 of 55] Compiling Text.Pandoc.Process ( src/Text/Pandoc/Process.hs, dist/build/Text/Pandoc/Process.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 3 of 55] Compiling Text.Pandoc.UUID ( src/Text/Pandoc/UUID.hs, dist/build/Text/Pandoc/UUID.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 4 of 55] Compiling Text.Pandoc.Slides ( src/Text/Pandoc/Slides.hs, dist/build/Text/Pandoc/Slides.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 5 of 55] Compiling Text.Pandoc.Readers.Haddock.Lex ( dist/build/Text/Pandoc/Readers/Haddock/Lex.hs, dist/build/Text/Pandoc/Readers/Haddock/Lex.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 6 of 55] Compiling Text.Pandoc.Readers.TeXMath ( src/Text/Pandoc/Readers/TeXMath.hs, dist/build/Text/Pandoc/Readers/TeXMath.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 7 of 55] Compiling Text.Pandoc.Compat.TagSoupEntity ( src/Text/Pandoc/Compat/TagSoupEntity.hs, dist/build/Text/Pandoc/Compat/TagSoupEntity.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 8 of 55] Compiling Text.Pandoc.Compat.Monoid ( src/Text/Pandoc/Compat/Monoid.hs, dist/build/Text/Pandoc/Compat/Monoid.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[ 9 of 55] Compiling Text.Pandoc.MIME ( src/Text/Pandoc/MIME.hs, dist/build/Text/Pandoc/MIME.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...
[10 of 55] Compiling Text.Pandoc.Pretty ( src/Text/Pandoc/Pretty.hs, dist/build/Text/Pandoc/Pretty.o )
You are using a new version of LLVM that hasn't been tested yet!
We will try though...

:-(
Comment 11 Jens Petersen 2014-05-09 05:42:38 EDT
Ah this is consistent with the earlier failure details above for Pretty.
Comment 12 Jens Petersen 2014-05-13 01:16:43 EDT
Also reproducible on Intel with llvm backend.


diff --git a/pandoc.spec b/pandoc.spec
index 7080d9a..120e19f 100644
--- a/pandoc.spec
+++ b/pandoc.spec
@@ -114,6 +114,7 @@ cabal-tweak-flag http-conduit False
 
 
 %build
+cabal_configure_extra_options=--ghc-option=-fllvm
 %ghc_lib_build
 
 
I was recommended to try using the gold linker on #haskell by carter.
Comment 13 Jens Petersen 2014-05-13 01:40:20 EDT
A workaround seems to be to build with "-O1".
Comment 14 Jens Petersen 2014-05-13 05:57:58 EDT
-O2 works okay with ghc-7.8 llvm.
Comment 15 Jens Petersen 2014-05-13 06:22:02 EDT
Fixing initially in pandoc-1.12.3.3-2.fc21.
Comment 16 Jens Petersen 2014-09-05 01:52:29 EDT
This fixed a while back:

https://admin.fedoraproject.org/updates/FEDORA-2014-6874/pandoc-1.12.3.3-2.fc20

Guess I forgot to link in this bug.

Note You need to log in before you can comment on or make changes to this bug.